﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Net.Sockets; //w3sz
using System.Threading;
using System.Collections.Concurrent;
using LiveCharts;
using LiveCharts.Defaults;
using LiveCharts.Wpf;
using LiveCharts.WinForms;
using LiveCharts.Geared;
using LiveCharts.Geared.Geometries;
using LiveCharts.Events;

namespace W3SZ_Remote_PowerMeter
{
    public partial class Form1 : Form
    {

        SetupForm Setup;
        public static bool closeflag = false;
        public bool maxSize = true;
        public string bandName;
        public string oldBandName;
        public int reverseBandNumber;
        public int bandNumber;
        public int secBandNumber;
        public int newBandNumber;


        String BANDA0 = Properties.Settings.Default.A0;      //turns sensor with this numeral on or off
        String BANDA1 = Properties.Settings.Default.A1;      //turns sensor with this numeral on or off
        String BANDA2 = Properties.Settings.Default.A2;      //turns sensor with this numeral on or off
        String BANDA3 = Properties.Settings.Default.A3;      //turns sensor with this numeral on or off
        String BANDA4 = Properties.Settings.Default.A4;      //turns sensor with this numeral on or off
        String BANDA5 = Properties.Settings.Default.A5;      //turns sensor with this numeral on or off
        String BANDA6 = Properties.Settings.Default.A6;      //turns sensor with this numeral on or off
        String BANDA7 = Properties.Settings.Default.A7;      //turns sensor with this numeral on or off
        String BANDA8 = Properties.Settings.Default.A8;      //turns sensor with this numeral on or off
        String BANDA9 = Properties.Settings.Default.A9;      //turns sensor with this numeral on or off
        String BANDA10 = Properties.Settings.Default.A10;      //turns sensor with this numeral on or off
        String BANDA11 = Properties.Settings.Default.A11;      //turns sensor with this numeral on or off
        String BANDA12 = Properties.Settings.Default.A12;      //turns sensor with this numeral on or off
        String BANDA13 = Properties.Settings.Default.A13;      //turns sensor with this numeral on or off
        String BANDA14 = Properties.Settings.Default.A14;      //turns sensor with this numeral on or off
        String BANDA15 = Properties.Settings.Default.A15;      //turns sensor with this numeral on or off


        public IDictionary<int, string> bandDict = new Dictionary<int, string>()
                                            {
                                                {0, (Properties.Settings.Default.labelA0.Trim()).Substring(0, Properties.Settings.Default.labelA0.IndexOf(' ')) },
                                                {1, (Properties.Settings.Default.labelA1.Trim()).Substring(0, Properties.Settings.Default.labelA1.IndexOf(' ')) },
                                                {2, (Properties.Settings.Default.labelA2.Trim()).Substring(0, Properties.Settings.Default.labelA2.IndexOf(' ')) },
                                                {3, (Properties.Settings.Default.labelA3.Trim()).Substring(0, Properties.Settings.Default.labelA3.IndexOf(' ')) },
                                                {4, (Properties.Settings.Default.labelA4.Trim()).Substring(0, Properties.Settings.Default.labelA4.IndexOf(' ')) },
                                                {5, (Properties.Settings.Default.labelA5.Trim()).Substring(0, Properties.Settings.Default.labelA5.IndexOf(' ')) },
                                                {6, (Properties.Settings.Default.labelA6.Trim()).Substring(0, Properties.Settings.Default.labelA6.IndexOf(' ')) },
                                                {7, (Properties.Settings.Default.labelA7.Trim()).Substring(0, Properties.Settings.Default.labelA7.IndexOf(' ')) },
                                                {8, (Properties.Settings.Default.labelA8.Trim()).Substring(0, Properties.Settings.Default.labelA8.IndexOf(' ')) },
                                                {9, (Properties.Settings.Default.labelA9.Trim()).Substring(0, Properties.Settings.Default.labelA9.IndexOf(' ')) },
                                                {10, (Properties.Settings.Default.labelA10.Trim()).Substring(0, Properties.Settings.Default.labelA10.IndexOf(' ')) },
                                                {11, (Properties.Settings.Default.labelA11.Trim()).Substring(0, Properties.Settings.Default.labelA11.IndexOf(' ')) },
                                                {12, (Properties.Settings.Default.labelA12.Trim()).Substring(0, Properties.Settings.Default.labelA12.IndexOf(' ')) },
                                                {13, (Properties.Settings.Default.labelA13.Trim()).Substring(0, Properties.Settings.Default.labelA13.IndexOf(' ')) },
                                                {14, (Properties.Settings.Default.labelA14.Trim()).Substring(0, Properties.Settings.Default.labelA15.IndexOf(' ')) },
                                                {15, (Properties.Settings.Default.labelA15.Trim()).Substring(0, Properties.Settings.Default.labelA15.IndexOf(' ')) }
                                            };

        public IDictionary<int, int> reverseDict = new Dictionary<int, int>()
                                            {
                                                {0, Properties.Settings.Default.R0 -1 },
                                                {1, Properties.Settings.Default.R1 -1  },
                                                {2, Properties.Settings.Default.R2 -1   },
                                                {3, Properties.Settings.Default.R3 -1   },
                                                {4, Properties.Settings.Default.R4 -1   },
                                                {5, Properties.Settings.Default.R5 -1   },
                                                {6, Properties.Settings.Default.R6 -1   },
                                                {7, Properties.Settings.Default.R7 -1   },
                                                {8, Properties.Settings.Default.R8 -1   },
                                                {9, Properties.Settings.Default.R9 -1   },
                                                {10, Properties.Settings.Default.R10 -1   },
                                                {11, Properties.Settings.Default.R11 -1   },
                                                {12, Properties.Settings.Default.R12 -1   },
                                                {13, Properties.Settings.Default.R13 -1   },
                                                {14, Properties.Settings.Default.R14 -1   },
                                                {15, Properties.Settings.Default.R15 -1   }
                                            };

        int dataPort = Properties.Settings.Default.dataPort;
        bool badCompIP = false;
        bool badArdIP = false;

        int rbutRev;  //indicates which radiobutton chosen for big data text boxes
        int rbutGraph;  //indicates which radiobutton chosen for graph
        int rbutSec;  //indicates which radiobutton chosen for big data text boxes

        string PowerOn = "OFF";  //turns measurement on or off

        string[] dataArray;  //input string from UDP
        double[] doubleDataArray;  //input data as doubles for A0 to A15
        double[] doubleDataArrayRaw;  //input data as doubles for A0 to A15 before calibration applies
        double[] avgDataArray;  //array of average values for A0 to A15

        double vRev = 0; // Reverse voltage, used for SWR calculation and displayed on graph if requested
        double vFwd = 0; //forward voltage chosen for main graph, big text box, and SWR calcs
        double avgvRev = 0; // Reverse voltage, used for SWR calculation 
        double avgvFwd = 0; //average forward voltage chosen for SWR calcs
        double SWR = 1.0;  //SWR calcuated
        double vSec = 0; //forward voltage for secondary graph, and its associated text boxes (avgSec and instSec)
        double avgvSec = 0; //forward voltage for secondary graph, and its associated text boxes (avgSec and instSec)

        int avgDur = 10; //number of values to average for average power calculation

        ConcurrentQueue<double> queueA0;
        ConcurrentQueue<double> queueA1;
        ConcurrentQueue<double> queueA2;
        ConcurrentQueue<double> queueA3;
        ConcurrentQueue<double> queueA4;
        ConcurrentQueue<double> queueA5;
        ConcurrentQueue<double> queueA6;
        ConcurrentQueue<double> queueA7;
        ConcurrentQueue<double> queueA8;
        ConcurrentQueue<double> queueA9;
        ConcurrentQueue<double> queueA10;
        ConcurrentQueue<double> queueA11;
        ConcurrentQueue<double> queueA12;
        ConcurrentQueue<double> queueA13;
        ConcurrentQueue<double> queueA14;
        ConcurrentQueue<double> queueA15;
        double queuedump;
        
        public ChartValues<double> InstFwdPower { get; set; }
        public ChartValues<double> InstRevPower { get; set; }
        public ChartValues<double> InstSecPower { get; set; }
        public SeriesCollection PowerPlots { get; set; }

        //UDP socket
        public static UdpClient udpServer1 = new UdpClient(); //w3sz
        public static IPEndPoint localpt1 = new IPEndPoint(IPAddress.Parse(Properties.Settings.Default.arduinoIP), Properties.Settings.Default.dataPort);  //w3sz

        public Form1()
        {
            InitializeComponent();

            doubleDataArray = new double[16];
            doubleDataArrayRaw = new double[16];

            checkBox1.Checked = Properties.Settings.Default.autoBand;
            trackBar1.Value = Properties.Settings.Default.avgDuration;

            queueA0 = new ConcurrentQueue<double>();
            queueA1 = new ConcurrentQueue<double>();
            queueA2 = new ConcurrentQueue<double>();
            queueA3 = new ConcurrentQueue<double>();
            queueA4 = new ConcurrentQueue<double>();
            queueA5 = new ConcurrentQueue<double>();
            queueA6 = new ConcurrentQueue<double>();
            queueA7 = new ConcurrentQueue<double>();
            queueA8 = new ConcurrentQueue<double>();
            queueA9 = new ConcurrentQueue<double>();
            queueA10 = new ConcurrentQueue<double>();
            queueA11 = new ConcurrentQueue<double>();
            queueA12 = new ConcurrentQueue<double>();
            queueA13 = new ConcurrentQueue<double>();
            queueA14 = new ConcurrentQueue<double>();
            queueA15 = new ConcurrentQueue<double>();
            avgDataArray = new double[16];

            for (int j = 0; j < doubleDataArray.Length; j++)
            {
                doubleDataArray[j] = 0;
                doubleDataArrayRaw[j] = 0;
            }



            InstFwdPower = new ChartValues<double>();
            InstRevPower = new ChartValues<double>();
            InstSecPower = new ChartValues<double>();


            System.Windows.Media.BrushConverter converter = new System.Windows.Media.BrushConverter();
            var brush = (System.Windows.Media.Brush)converter.ConvertFromString("#000000");
            if (brush.CanFreeze)
            {
                brush.Freeze();
            }


            PowerPlots = new SeriesCollection
            {
                new LineSeries
                {
                Title = "Forward Power",
                Values = InstFwdPower,
                PointGeometry = DefaultGeometries.Diamond,
                },
                new LineSeries
                {
                Title = "Reflected Power",
                Values = InstRevPower,
                PointGeometry = DefaultGeometries.Diamond,
                },
                new LineSeries
                {
                Title = "Secondary Power",
                Values = InstSecPower,
                PointGeometry = DefaultGeometries.Diamond,
                }
            };


            PowerGraph.AxisY.Add(new Axis
            {
                Position = AxisPosition.LeftBottom,
                Title = "Watts",
                MinValue = 0,
                Foreground = brush,
                FontWeight = System.Windows.FontWeights.Bold,
                FontSize = 15,
                Separator = new Separator
                {
                    Stroke = brush
                },
            });
            
            PowerGraph.AxisX.Add(new Axis
            {
                Position = AxisPosition.LeftBottom,
                Title = "Seconds",
                MinValue = double.NaN,
                MinRange = 10,
                Foreground = brush,
                FontWeight = System.Windows.FontWeights.Bold,
                FontSize = 15,
                Separator = new Separator
                {
                    Stroke = brush
                }
            });
            

            PowerGraph.Hoverable = false;
            PowerGraph.DataTooltip = null;
            PowerGraph.DisableAnimations = true;
            PowerGraph.Series = PowerPlots;
            PowerGraph.LegendLocation = LegendLocation.Top;
            
            butA0.Text = Properties.Settings.Default.labelA0;
            butA1.Text = Properties.Settings.Default.labelA1;
            butA2.Text = Properties.Settings.Default.labelA2;
            butA3.Text = Properties.Settings.Default.labelA3;
            butA4.Text = Properties.Settings.Default.labelA4;
            butA5.Text = Properties.Settings.Default.labelA5;
            butA6.Text = Properties.Settings.Default.labelA6;
            butA7.Text = Properties.Settings.Default.labelA7;
            butA8.Text = Properties.Settings.Default.labelA8;
            butA9.Text = Properties.Settings.Default.labelA9;
            butA10.Text = Properties.Settings.Default.labelA10;
            butA11.Text = Properties.Settings.Default.labelA11;
            butA12.Text = Properties.Settings.Default.labelA12;
            butA13.Text = Properties.Settings.Default.labelA13;
            butA14.Text = Properties.Settings.Default.labelA14;
            butA15.Text = Properties.Settings.Default.labelA15;
            rbutRev = Properties.Settings.Default.rbutRev;
            rbutGraph = Properties.Settings.Default.rbutGraph;
            rbutSec = Properties.Settings.Default.rbutSec;

            switch (rbutRev)
            {
                case 0:
                    {
                        radioButton0a.Checked = true;
                        break;
                    }
                case 1:
                    {
                        radioButton1a.Checked = true;
                        break;
                    }
                case 2:
                    {
                        radioButton2a.Checked = true;
                        break;
                    }
                case 3:
                    {
                        radioButton3a.Checked = true;
                        break;
                    }
                case 4:
                    {
                        radioButton4a.Checked = true;
                        break;
                    }
                case 5:
                    {
                        radioButton5a.Checked = true;
                        break;
                    }
                case 6:
                    {
                        radioButton6a.Checked = true;
                        break;
                    }
                case 7:
                    {
                        radioButton7a.Checked = true;
                        break;
                    }
                case 8:
                    {
                        radioButton8a.Checked = true;
                        break;
                    }
                case 9:
                    {
                        radioButton9a.Checked = true;
                        break;
                    }
                case 10:
                    {
                        radioButton10a.Checked = true;
                        break;
                    }
                case 11:
                    {
                        radioButton11a.Checked = true;
                        break;
                    }
                case 12:
                    {
                        radioButton12a.Checked = true;
                        break;
                    }
                case 13:
                    {
                        radioButton13a.Checked = true;
                        break;
                    }
                case 14:
                    {
                        radioButton14a.Checked = true;
                        break;
                    }
                case 15:
                    {
                        radioButton15a.Checked = true;
                        break;
                    }
                case 99:
                    {
                        radioButtonNONE.Checked = true;
                        break;
                    }
            }


            switch (rbutGraph)
            {
                case 0:
                    {
                        radioButton0.Checked = true;
                        break;
                    }
                case 1:
                    {
                        radioButton1.Checked = true;
                        break;
                    }
                case 2:
                    {
                        radioButton2.Checked = true;
                        break;
                    }
                case 3:
                    {
                        radioButton3.Checked = true;
                        break;
                    }
                case 4:
                    {
                        radioButton4.Checked = true;
                        break;
                    }
                case 5:
                    {
                        radioButton5.Checked = true;
                        break;
                    }
                case 6:
                    {
                        radioButton6.Checked = true;
                        break;
                    }
                case 7:
                    {
                        radioButton7.Checked = true;
                        break;
                    }
                case 8:
                    {
                        radioButton8.Checked = true;
                        break;
                    }
                case 9:
                    {
                        radioButton9.Checked = true;
                        break;
                    }
                case 10:
                    {
                        radioButton10.Checked = true;
                        break;
                    }
                case 11:
                    {
                        radioButton11.Checked = true;
                        break;
                    }
                case 12:
                    {
                        radioButton12.Checked = true;
                        break;
                    }
                case 13:
                    {
                        radioButton13.Checked = true;
                        break;
                    }
                case 14:
                    {
                        radioButton14.Checked = true;
                        break;
                    }
                case 15:
                    {
                        radioButton15.Checked = true;
                        break;
                    }
            }


            switch (rbutSec)
            {
                case 0:
                    {
                        radioButton0b.Checked = true;
                        break;
                    }
                case 1:
                    {
                        radioButton1b.Checked = true;
                        break;
                    }
                case 2:
                    {
                        radioButton2b.Checked = true;
                        break;
                    }
                case 3:
                    {
                        radioButton3b.Checked = true;
                        break;
                    }
                case 4:
                    {
                        radioButton4b.Checked = true;
                        break;
                    }
                case 5:
                    {
                        radioButton5b.Checked = true;
                        break;
                    }
                case 6:
                    {
                        radioButton6b.Checked = true;
                        break;
                    }
                case 7:
                    {
                        radioButton7b.Checked = true;
                        break;
                    }
                case 8:
                    {
                        radioButton8b.Checked = true;
                        break;
                    }
                case 9:
                    {
                        radioButton9b.Checked = true;
                        break;
                    }
                case 10:
                    {
                        radioButton10b.Checked = true;
                        break;
                    }
                case 11:
                    {
                        radioButton11b.Checked = true;
                        break;
                    }
                case 12:
                    {
                        radioButton12b.Checked = true;
                        break;
                    }
                case 13:
                    {
                        radioButton13b.Checked = true;
                        break;
                    }
                case 14:
                    {
                        radioButton14b.Checked = true;
                        break;
                    }
                case 15:
                    {
                        radioButton15b.Checked = true;
                        break;
                    }
                case 99:
                    {
                        radioButtonSec.Checked = true;
                        break;
                    }
            }

            if (BANDA0 == "ON")
            {
                butA0.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA0ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA0.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA0OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA1 == "ON")
            {
                butA1.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA1ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA1.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA1OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA2 == "ON")
            {
                butA2.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA2ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA2.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA2OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA3 == "ON")
            {
                butA3.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA3ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA3.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA3OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA4 == "ON")
            {
                butA4.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA4ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA4.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA4OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA5 == "ON")
            {
                butA5.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA5ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA5.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA5OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA6 == "ON")
            {
                butA6.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA6ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA6.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA6OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA7 == "ON")
            {
                butA7.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA7ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA7.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA7OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA8 == "ON")
            {
                butA8.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA8ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA8.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA8OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA9 == "ON")
            {
                butA9.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA9ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA9.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA9OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA10 == "ON")
            {
                butA10.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA01ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA10.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA10OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA11 == "ON")
            {
                butA11.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA11ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA11.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA11OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA12 == "ON")
            {
                butA12.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA12ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA12.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA12OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA13 == "ON")
            {
                butA13.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA13ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA13.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA13OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA14 == "ON")
            {
                butA14.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA14ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA14.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA14OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            if (BANDA15 == "ON")
            {
                butA15.BackColor = Color.Yellow;
                byte[] textstrng = StrToByteArray("~BANDA15ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }
            else
            {
                butA15.BackColor = SystemColors.Control;
                byte[] textstrng = StrToByteArray("~BANDA15OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            }


            startThreads();



        }

        public void startThreads()
        {
            Console.WriteLine("Starting Data Receive Thread");
            // start getting UDP data from Arduino and place in circular buffer section
            ThreadPool.QueueUserWorkItem(delegate //w3sz
            {
                UdpClient udpServer = new UdpClient(Properties.Settings.Default.dataPort);
                IPEndPoint localpt = new IPEndPoint(IPAddress.Parse(Properties.Settings.Default.arduinoIP), Properties.Settings.Default.dataPort); //w3sz spectrum data receiver

                while (Globals.stopper == false) //w3sz
                {
                    try
                    {
                        byte[] buffer = udpServer.Receive(ref localpt); //w3sz
                        string sbuffer = Encoding.UTF8.GetString(buffer, 0, buffer.Length);
                        //put data handling routines here
                        Console.WriteLine(sbuffer);
                        Console.WriteLine();
                        parseData(sbuffer);
                        processData();
                    }
                    catch
                    {
                        Console.WriteLine("Exception occurred in initial thread");
                    }
                }

                Console.WriteLine("Ended Data Receive Thread");
            });

        }


        public void processData()
        {
            Console.WriteLine("avgDur = {0}", avgDur);
            if (BANDA0 == "ON")
                {
                textBox0i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox0i.Text = doubleDataArray[0].ToString("F0");
                    }));
                queueA0.Enqueue(doubleDataArray[0]);
                while (queueA0.Count >  avgDur)
                {
                    queueA0.TryDequeue(out queuedump);
                }
                avgDataArray[0] = queueA0.Average();
                textBox0a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox0a.Text = avgDataArray[0].ToString("F0");
                    }));
                }
            else
            {
                textBox0i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox0i.Clear();
                    }));
                textBox0a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox0a.Clear();
                    }));
            }
            if (BANDA1 == "ON")
            {
                textBox1i.BeginInvoke(
                (Action)(() =>
                {
                    textBox1i.Text = doubleDataArray[1].ToString("F0");
                }));
                queueA1.Enqueue(doubleDataArray[1]);
                while (queueA1.Count >  avgDur)
                {
                    queueA1.TryDequeue(out queuedump);
                }
                avgDataArray[1] = queueA1.Average();
                textBox1a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox1a.Text = avgDataArray[1].ToString("F0");
                    }));
            }
            else
            {
                textBox1i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox1i.Clear();
                    }));
                textBox1a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox1a.Clear();
                    }));
            }
            if (BANDA2 == "ON")
            {
                textBox2i.BeginInvoke(
                (Action)(() =>
                {
                    textBox2i.Text = doubleDataArray[2].ToString("F0");
                }));
                queueA2.Enqueue(doubleDataArray[2]);
                while (queueA2.Count >  avgDur)
                {
                    queueA2.TryDequeue(out queuedump);
                }
                avgDataArray[2] = queueA2.Average();
                textBox2a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox2a.Text = avgDataArray[2].ToString("F0");
                    }));
            }
            else
            {
                textBox2i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox2i.Clear();
                    }));
                textBox2a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox2a.Clear();
                    }));
            }
            if (BANDA3 == "ON")
            {
                textBox3i.BeginInvoke(
                (Action)(() =>
                {
                    textBox3i.Text = doubleDataArray[3].ToString("F0");
                }));
                queueA3.Enqueue(doubleDataArray[3]);
                while (queueA3.Count >  avgDur)
                {
                    queueA3.TryDequeue(out queuedump);
                }
                avgDataArray[3] = queueA3.Average();
                textBox3a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox3a.Text = avgDataArray[3].ToString("F0");
                    }));
            }
            else
            {
                textBox3i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox3i.Clear();
                    }));
                textBox3a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox3a.Clear();
                    }));
            }
            if (BANDA4 == "ON")
            {
                textBox4i.BeginInvoke(
                (Action)(() =>
                {
                    textBox4i.Text = doubleDataArray[4].ToString("F0");
                }));
                queueA4.Enqueue(doubleDataArray[4]);
                while (queueA4.Count >  avgDur)
                {
                    queueA4.TryDequeue(out queuedump);
                }
                avgDataArray[4] = queueA4.Average();
                textBox4a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox4a.Text = avgDataArray[4].ToString("F0");
                    }));
            }
            else
            {
                textBox4i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox4i.Clear();
                    }));
                textBox4a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox4a.Clear();
                    }));
            }

            if (BANDA5 == "ON")
            {
                textBox5i.BeginInvoke(
                (Action)(() =>
                {
                    textBox5i.Text = doubleDataArray[5].ToString("F0");
                }));
                queueA5.Enqueue(doubleDataArray[5]);
                while (queueA5.Count >  avgDur)
                {
                    queueA5.TryDequeue(out queuedump);
                }
                avgDataArray[5] = queueA5.Average();
                textBox5a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox5a.Text = avgDataArray[5].ToString("F0");
                    }));
            }
            else
            {
                textBox5i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox5i.Clear();
                    }));
                textBox5a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox5a.Clear();
                    }));
            }
            if (BANDA6 == "ON")
            {
                textBox6i.BeginInvoke(
            (Action)(() =>
            {
                textBox6i.Text = doubleDataArray[6].ToString("F0");
            }));
                queueA6.Enqueue(doubleDataArray[6]);
                while (queueA6.Count >  avgDur)
                {
                    queueA6.TryDequeue(out queuedump);
                }
                avgDataArray[6] = queueA6.Average();
                textBox6a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox6a.Text = avgDataArray[6].ToString("F0");
                    }));
            }
            else
            {
                textBox6i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox6i.Clear();
                    }));
                textBox6a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox6a.Clear();
                    }));
            }

            if (BANDA7 == "ON")
            {
            textBox7i.BeginInvoke(
                (Action)(() =>
                {
                    textBox7i.Text = doubleDataArray[7].ToString("F0");
                }));
                queueA7.Enqueue(doubleDataArray[7]);
                while (queueA7.Count >  avgDur)
                {
                    queueA7.TryDequeue(out queuedump);
                }
                avgDataArray[7] = queueA7.Average();
                textBox7a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox7a.Text = avgDataArray[7].ToString("F0");
                    }));
            }
            else
            {
                textBox7i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox7i.Clear();
                    }));
                textBox7a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox7a.Clear();
                    }));
            }
            if (BANDA8 == "ON")
            {
                textBox8i.BeginInvoke(
                (Action)(() =>
                {
                    textBox8i.Text = doubleDataArray[8].ToString("F0");
                }));
                queueA8.Enqueue(doubleDataArray[8]);
                while (queueA8.Count >  avgDur)
                {
                    queueA8.TryDequeue(out queuedump);
                }
                avgDataArray[8] = queueA8.Average();
                textBox8a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox8a.Text = avgDataArray[8].ToString("F0");
                    }));
            }
            else
            {
                textBox8i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox8i.Clear();
                    }));
                textBox8a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox8a.Clear();
                    }));
            }
            if (BANDA9 == "ON")
            {
                textBox9i.BeginInvoke(
                (Action)(() =>
                {
                    textBox9i.Text = doubleDataArray[9].ToString("F0");
                }));
                queueA9.Enqueue(doubleDataArray[9]);
                while (queueA9.Count >  avgDur)
                {
                    queueA9.TryDequeue(out queuedump);
                }
                avgDataArray[9] = queueA9.Average();
                textBox9a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox9a.Text = avgDataArray[9].ToString("F0");
                    }));
            }
            else
            {
                textBox9i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox9i.Clear();
                    }));
                textBox9a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox9a.Clear();
                    }));
            }
            if (BANDA10 == "ON")
            {
                textBox10i.BeginInvoke(
                (Action)(() =>
                {
                    textBox10i.Text = doubleDataArray[10].ToString("F0");
                }));
                queueA10.Enqueue(doubleDataArray[10]);
                while (queueA10.Count >  avgDur)
                {
                    queueA10.TryDequeue(out queuedump);
                }
                avgDataArray[10] = queueA10.Average();
                textBox10a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox10a.Text = avgDataArray[10].ToString("F0");
                    }));
            }
            else
            {
                textBox10i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox10i.Clear();
                    }));
                textBox10a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox10a.Clear();
                    }));
            }
            if (BANDA11 == "ON")
            {
                textBox11i.BeginInvoke(
                (Action)(() =>
                {
                    textBox11i.Text = doubleDataArray[11].ToString("F0");
                }));
                queueA11.Enqueue(doubleDataArray[11]);
                while (queueA11.Count >  avgDur)
                {
                    queueA11.TryDequeue(out queuedump);
                }
                avgDataArray[11] = queueA11.Average();
                textBox11a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox11a.Text = avgDataArray[11].ToString("F0");
                    }));
            }
            else
            {
                textBox11i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox11i.Clear();
                    }));
                textBox11a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox11a.Clear();
                    }));
            }
            if (BANDA12 == "ON")
            {
                textBox12i.BeginInvoke(
                (Action)(() =>
                {
                    textBox12i.Text = doubleDataArray[12].ToString("F0");
                }));
                queueA12.Enqueue(doubleDataArray[12]);
                while (queueA12.Count >  avgDur)
                {
                    queueA12.TryDequeue(out queuedump);
                }
                avgDataArray[12] = queueA12.Average();
                textBox12a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox12a.Text = avgDataArray[12].ToString("F0");
                    }));
            }
            else
            {
                textBox12i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox12i.Clear();
                    }));
                textBox12a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox12a.Clear();
                    }));
            }
            if (BANDA13 == "ON")
            {
                textBox13i.BeginInvoke(
                (Action)(() =>
                {
                    textBox13i.Text = doubleDataArray[13].ToString("F0");
                }));
                queueA13.Enqueue(doubleDataArray[13]);
                while (queueA13.Count >  avgDur)
                {
                    queueA13.TryDequeue(out queuedump);
                }
                avgDataArray[13] = queueA13.Average();
                textBox13a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox13a.Text = avgDataArray[13].ToString("F0");
                    }));
            }
            else
            {
                textBox13i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox13i.Clear();
                    }));
                textBox13a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox13a.Clear();
                    }));
            }
            if (BANDA14 == "ON")
            {
                textBox14i.BeginInvoke(
                (Action)(() =>
                {
                    textBox14i.Text = doubleDataArray[14].ToString("F0");
                }));
                queueA14.Enqueue(doubleDataArray[14]);
                while (queueA14.Count >  avgDur)
                {
                    queueA14.TryDequeue(out queuedump);
                }
                avgDataArray[14] = queueA14.Average();
                textBox14a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox14a.Text = avgDataArray[14].ToString("F0");
                    }));
            }
            else
            {
                textBox14i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox14i.Clear();
                    }));
                textBox14a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox14a.Clear();
                    }));
            }
            if (BANDA15 == "ON")
            {
                textBox15i.BeginInvoke(
                (Action)(() =>
                {
                    textBox15i.Text = doubleDataArray[15].ToString("F0");
                }));
                queueA15.Enqueue(doubleDataArray[15]);
                while (queueA15.Count >  avgDur)
                {
                    queueA15.TryDequeue(out queuedump);
                }
                avgDataArray[15] = queueA15.Average();
                textBox15a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox15a.Text = avgDataArray[15].ToString("F0");
                    }));
            }
            else
            {
                textBox15i.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox15i.Clear();
                    }));
                textBox15a.BeginInvoke(
                    (Action)(() =>
                    {
                        textBox15a.Clear();
                    }));
            }

            if (!Properties.Settings.Default.autoBand)
            {
                switch (rbutRev)
                {
                    case 0:
                        {
                            vRev = doubleDataArray[0];
                            avgvRev = avgDataArray[0];
                            break;
                        }
                    case 1:
                        {
                            vRev = doubleDataArray[1];
                            avgvRev = avgDataArray[1];
                            break;
                        }
                    case 2:
                        {
                            vRev = doubleDataArray[2];
                            avgvRev = avgDataArray[2];
                            break;
                        }
                    case 3:
                        {
                            vRev = doubleDataArray[3];
                            avgvRev = avgDataArray[3];
                            break;
                        }
                    case 4:
                        {
                            vRev = doubleDataArray[4];
                            avgvRev = avgDataArray[4];
                            break;
                        }
                    case 5:
                        {
                            vRev = doubleDataArray[5];
                            avgvRev = avgDataArray[5];
                            break;
                        }
                    case 6:
                        {
                            vRev = doubleDataArray[6];
                            avgvRev = avgDataArray[6];
                            break;
                        }
                    case 7:
                        {
                            vRev = doubleDataArray[7];
                            avgvRev = avgDataArray[7];
                            break;
                        }
                    case 8:
                        {
                            vRev = doubleDataArray[8];
                            avgvRev = avgDataArray[8];
                            break;
                        }
                    case 9:
                        {
                            vRev = doubleDataArray[9];
                            avgvRev = avgDataArray[9];
                            break;
                        }
                    case 10:
                        {
                            vRev = doubleDataArray[10];
                            avgvRev = avgDataArray[10];
                            break;
                        }
                    case 11:
                        {
                            vRev = doubleDataArray[11];
                            avgvRev = avgDataArray[11];
                            break;
                        }
                    case 12:
                        {
                            vRev = doubleDataArray[12];
                            avgvRev = avgDataArray[12];
                            break;
                        }
                    case 13:
                        {
                            vRev = doubleDataArray[13];
                            avgvRev = avgDataArray[13];
                            break;
                        }
                    case 14:
                        {
                            vRev = doubleDataArray[14];
                            avgvRev = avgDataArray[14];
                            break;
                        }
                    case 15:
                        {
                            vRev = doubleDataArray[15];
                            avgvRev = avgDataArray[15];
                            break;
                        }
                    case 99:
                        {
                            vRev = 0;
                            avgvRev = 0;
                            break;
                        }

                }


                switch (rbutGraph)
                {
                    case 0:
                        {
                            vFwd = doubleDataArray[0];
                            avgvFwd = avgDataArray[0];
                            break;
                        }
                    case 1:
                        {
                            vFwd = doubleDataArray[1];
                            avgvFwd = avgDataArray[1];
                            break;
                        }
                    case 2:
                        {
                            vFwd = doubleDataArray[2];
                            avgvFwd = avgDataArray[2];
                            break;
                        }
                    case 3:
                        {
                            vFwd = doubleDataArray[3];
                            avgvFwd = avgDataArray[3];
                            break;
                        }
                    case 4:
                        {
                            vFwd = doubleDataArray[4];
                            avgvFwd = avgDataArray[4];
                            break;
                        }
                    case 5:
                        {
                            vFwd = doubleDataArray[5];
                            avgvFwd = avgDataArray[5];
                            break;
                        }
                    case 6:
                        {
                            vFwd = doubleDataArray[6];
                            avgvFwd = avgDataArray[6];
                            break;
                        }
                    case 7:
                        {
                            vFwd = doubleDataArray[7];
                            avgvFwd = avgDataArray[7];
                            break;
                        }
                    case 8:
                        {
                            vFwd = doubleDataArray[8];
                            avgvFwd = avgDataArray[8];
                            break;
                        }
                    case 9:
                        {
                            vFwd = doubleDataArray[9];
                            avgvFwd = avgDataArray[9];
                            break;
                        }
                    case 10:
                        {
                            vFwd = doubleDataArray[10];
                            avgvFwd = avgDataArray[10];
                            break;
                        }
                    case 11:
                        {
                            vFwd = doubleDataArray[11];
                            avgvFwd = avgDataArray[11];
                            break;
                        }
                    case 12:
                        {
                            vFwd = doubleDataArray[12];
                            avgvFwd = avgDataArray[12];
                            break;
                        }
                    case 13:
                        {
                            vFwd = doubleDataArray[13];
                            avgvFwd = avgDataArray[13];
                            break;
                        }
                    case 14:
                        {
                            vFwd = doubleDataArray[14];
                            avgvFwd = avgDataArray[14];
                            break;
                        }
                    case 15:
                        {
                            vFwd = doubleDataArray[15];
                            avgvFwd = avgDataArray[15];
                            break;
                        }
                }



                switch (rbutSec)
                {
                    case 0:
                        {
                            vSec = doubleDataArray[0];
                            avgvSec = avgDataArray[0];
                            break;
                        }
                    case 1:
                        {
                            vSec = doubleDataArray[1];
                            avgvSec = avgDataArray[1];
                            break;
                        }
                    case 2:
                        {
                            vSec = doubleDataArray[2];
                            avgvSec = avgDataArray[2];
                            break;
                        }
                    case 3:
                        {
                            vSec = doubleDataArray[3];
                            avgvSec = avgDataArray[3];
                            break;
                        }
                    case 4:
                        {
                            vSec = doubleDataArray[4];
                            avgvSec = avgDataArray[4];
                            break;
                        }
                    case 5:
                        {
                            vSec = doubleDataArray[5];
                            avgvSec = avgDataArray[5];
                            break;
                        }
                    case 6:
                        {
                            vSec = doubleDataArray[6];
                            avgvSec = avgDataArray[6];
                            break;
                        }
                    case 7:
                        {
                            vSec = doubleDataArray[7];
                            avgvSec = avgDataArray[7];
                            break;
                        }
                    case 8:
                        {
                            vSec = doubleDataArray[8];
                            avgvSec = avgDataArray[8];
                            break;
                        }
                    case 9:
                        {
                            vSec = doubleDataArray[9];
                            avgvSec = avgDataArray[9];
                            break;
                        }
                    case 10:
                        {
                            vSec = doubleDataArray[10];
                            avgvSec = avgDataArray[10];
                            break;
                        }
                    case 11:
                        {
                            vSec = doubleDataArray[11];
                            avgvSec = avgDataArray[11];
                            break;
                        }
                    case 12:
                        {
                            vSec = doubleDataArray[12];
                            avgvSec = avgDataArray[12];
                            break;
                        }
                    case 13:
                        {
                            vSec = doubleDataArray[13];
                            avgvSec = avgDataArray[13];
                            break;
                        }
                    case 14:
                        {
                            vSec = doubleDataArray[14];
                            avgvSec = avgDataArray[14];
                            break;
                        }
                    case 15:
                        {
                            vSec = doubleDataArray[15];
                            avgvSec = avgDataArray[15];
                            break;
                        }
                    case 99:
                        {
                            vSec = 0;
                            avgvSec = 0;
                            break;
                        }
                }
            }

            else
            {
                vFwd = doubleDataArray[bandNumber];
                avgvFwd = avgDataArray[bandNumber];
                if (reverseBandNumber >= 0)
                {
                    vRev = doubleDataArray[reverseBandNumber];
                    avgvRev = doubleDataArray[reverseBandNumber];
                }
                else
                {
                    vRev = 0;
                    avgvRev = 0;
                }
            }

            PowerGraph.Series[0].Values.Add(vFwd);
            PowerGraph.Series[1].Values.Add(vRev);
            PowerGraph.Series[2].Values.Add(vSec);

           

            while (InstFwdPower.Count > 90 || InstRevPower.Count > 90 || InstSecPower.Count > 90)
            {
                if (InstFwdPower.Count > 90) InstFwdPower.RemoveAt(0);
                if (InstRevPower.Count > 90) InstRevPower.RemoveAt(0);
                if (InstSecPower.Count > 90) InstSecPower.RemoveAt(0);
            }

            bigInst.BeginInvoke(
                             (Action)(() =>
                             {
                                 bigInst.Text = vFwd.ToString("F0");
                             }));
            bigAvg.BeginInvoke(
                             (Action)(() =>
                             {
                                 bigAvg.Text = avgvFwd.ToString("F0");
                             }));
            avgSec.BeginInvoke(
                             (Action)(() =>
                             {
                                 avgSec.Text = vSec.ToString("F0");
                             }));
            instSec.BeginInvoke(
                             (Action)(() =>
                             {
                                 instSec.Text = avgvSec.ToString("F0");
                             }));
            double vRat = Math.Sqrt(avgvRev / avgvFwd);
            SWR = (1 + vRat) / (1 - vRat);
            Console.WriteLine("SWR IS {0} and maxsize is {1} and reverseBandNumber is {2}", SWR, maxSize, reverseBandNumber);

            string controlName = "butA" + reverseBandNumber.ToString();
            Console.WriteLine("Control name is {0}", controlName);
            Control ctn = this.Controls[controlName];


//            if (((rbutRev < 20) && (!Properties.Settings.Default.autoBand)) || (Properties.Settings.Default.autoBand && reverseBandNumber >= 0) && (avgvFwd > 0))
            if ((((rbutRev < 20) && (!Properties.Settings.Default.autoBand)) || (Properties.Settings.Default.autoBand && (ctn.BackColor == Color.Yellow))) && (avgvFwd > 0) )
            {


                if (SWR > 10)
                {
                    bigSWR.BeginInvoke(
                               (Action)(() =>
                               {
                                   bigSWR.Text = ">10";
                               }));
                }
                else if (SWR >= 1.0)
                {
                    bigSWR.BeginInvoke(
                                 (Action)(() =>
                                 {
                                     bigSWR.Text = SWR.ToString("F1");
                                 }));

                }
                else
                {
                    bigSWR.BeginInvoke(
                               (Action)(() =>
                               {
                                   bigSWR.Text = ">10";
                               }));
                }
            }
            else
            {
                bigSWR.BeginInvoke(
                             (Action)(() =>
                             {
                                 bigSWR.Text = " ";
                             }));
            }
            
        }


        public void parseData(string data)
        {
            Array.Clear(doubleDataArray, 0, 16);
            Array.Clear(doubleDataArrayRaw, 0, 16);

            double testdoub;
            data = data.Substring(5);
            dataArray = data.Split(',');
            for (int i = 0; i < dataArray.Length; i++)
            {
                string test = dataArray[i].Substring(0, 3);
                //         Console.WriteLine(test);
                switch (test)
                {
                    case "A00":  //50 MHz 500 W slug
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[0] = testdoub;
                                double A = 4110.3399434534094;
                                double B = -405.29309946081304;
                                double C = 67.033730899934895;
                                double OffsetValue = -10.498644581822925;
                                testdoub = A * Math.Exp(B / (doubleDataArrayRaw[0] + C)) + OffsetValue;
                                if (doubleDataArrayRaw[0] == 0) testdoub = 0;
                                doubleDataArray[0] = testdoub;
                            }
                            break;
                        }
                    case "A01":  //50 MHz ref 1000 W slug
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[1] = testdoub;
                                double A = 3.0262700435489241E+05;
                                double B = -2.0339360883499958E+03;
                                double C = 2.5744578319349466E+02;
                                double OffsetValue = -1.0096366581924116E+02;
                                testdoub = A * Math.Exp(B / (doubleDataArrayRaw[1] + C)) + OffsetValue;
                                if (doubleDataArrayRaw[1] == 0) testdoub = 0;
                                doubleDataArray[1] = testdoub;
                            }
                            break;
                        }
                    case "A02":  //144 MHz 500 W slug
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[2] = testdoub;
                                double A = 2.6572067444272074E+04;
                                double B = -1.2240568519753560E+03;
                                double C = 1.8361725322608544E+02;
                                double OffsetValue = -3.2819576472201618E+01;
                                testdoub = A * Math.Exp(B / (doubleDataArrayRaw[2] + C)) + OffsetValue;
                                if (doubleDataArrayRaw[2] == 0) testdoub = 0;
                                doubleDataArray[2] = testdoub;
                            }
                            break;
                        }
                    case "A03":  //144 MHz ref 100 W slug
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[3] = testdoub;
                                double A = 9.4078123445082543E+04;
                                double B = -3.4716627096255424E+03;
                                double C = 4.0284637704496475E+02;
                                double OffsetValue = -1.6429874257448887E+01;
                                testdoub = A * Math.Exp(B / (doubleDataArrayRaw[3] + C)) + OffsetValue;
                                if (doubleDataArrayRaw[3] == 0) testdoub = 0;
                                doubleDataArray[3] = testdoub;
                            }
                            break;
                        }
                    case "A04":  //222 MHz 100 W slug
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[4] = testdoub;
                                double A = 3.6525557445111008E+04;
                                double B = -3.0271414111888471E+03;
                                double C = 3.7758519610392409E+02;
                                double OffsetValue = -1.2006717933497011E+01;
                                testdoub = A * Math.Exp(B / (doubleDataArrayRaw[4] + C)) + OffsetValue;
                                if (doubleDataArrayRaw[4] == 0) testdoub = 0;
                                doubleDataArray[4] = testdoub;
                            }
                            break;
                        }
                    case "A05":  //222 MHz ref
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[5] = testdoub;
                                doubleDataArray[5] = testdoub;
                            }
                            break;
                        }
                    case "A06":  //432 MHz 250 W slug
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[6] = testdoub;
                                double A = 4.2759030042915356E+03;
                                double B = -7.0992715961365684E+02;
                                double C = 1.0542589158556116E+02;
                                double OffsetValue = -3.8476554065556376E+00;
                                testdoub = A * Math.Exp(B / (doubleDataArrayRaw[6] + C)) + OffsetValue;
                                if (doubleDataArrayRaw[6] == 0) testdoub = 0;
                                doubleDataArray[6] = testdoub;
                            }
                            break;
                        }
                    case "A07":  //432 MHz ref
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[7] = testdoub;
                                doubleDataArray[7] = testdoub;
                            }
                            break;
                        }
                    case "A08":  //902 MHz
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[8] = testdoub;
                                double A = 6.2529560311475007E+02;
                                double B = -9.4709276147755439E+00;
                                double C = -1.8289768380952418E+02;
                                double OffsetValue = -6.5818644334732710E+02;
                                testdoub = A * Math.Exp(B / (doubleDataArrayRaw[8] + C)) + OffsetValue;
                                if (doubleDataArrayRaw[8] == 0) testdoub = 0;
                                doubleDataArray[8] = testdoub;
                            }
                            break;
                        }
                    case "A09":  //902 MHz ref
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[9] = testdoub;
                                doubleDataArray[9] = testdoub;
                            }
                            break;
                        }
                    case "A10": //1296 MHz 25 W slug
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[10] = testdoub;
                                double A = 2.2492525576879771E-44;
                                double B = -8.3517758259022422E+05;
                                double C = -8.1294971884504339E+03;
                                double OffsetValue = -9.3276892330041115E+00;
                                testdoub = A * Math.Exp(B / (doubleDataArrayRaw[10] + C)) + OffsetValue;
                                if (doubleDataArrayRaw[10] == 0) testdoub = 0;
                                doubleDataArray[10] = testdoub;
                            }
                            break;
                        }
                    case "A11":  //1296 MHz ref
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[11] = testdoub;
                                doubleDataArray[11] = testdoub;
                            }
                            break;
                        }
                    case "A12":  //10 GHz
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[12] = testdoub - 18;
                                if (testdoub > 22)
                                {
                                    testdoub = doubleDataArrayRaw[12] * 0.05027933;
                                }
                                else
                                {
                                    testdoub = 0;
                                    doubleDataArrayRaw[12] = 0;
                                }
                                doubleDataArray[12] = testdoub;
                            }
                            break;
                        }
                    case "A13":
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[13] = testdoub;
                                doubleDataArray[13] = testdoub;
                            }
                            break;
                        }
                    case "A14":
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[14] = testdoub;
                                doubleDataArray[14] = testdoub;
                            }
                            break;
                        }
                    case "A15":
                        {
                            if (double.TryParse(dataArray[i].Substring(4), out testdoub))
                            {
                                doubleDataArrayRaw[15] = testdoub;
                                doubleDataArray[15] = testdoub;
                            }
                            break;
                        }
                    default:
                        {
                            testdoub = 0;
                            break;
                        }
                }

            }

            newBandNumber = doubleDataArrayRaw.ToList().IndexOf(doubleDataArrayRaw.Max());
            string controlName = "butA" + newBandNumber.ToString();
            Console.WriteLine("Control name is {0}", controlName);
            Control ctn = this.Controls[controlName];

            if(ctn.BackColor == Color.Yellow)
            {
                bandNumber = newBandNumber;
            }

            if (!Properties.Settings.Default.autoBand)
            {
                bandName = bandDict[rbutGraph];
                bandLabel.Invoke(
                    (Action)(() =>
                    {
                        bandLabel.Text = bandName;
                    }));
                if (rbutSec<99)
                {
                    secLabel.Invoke(
                    (Action)(() =>
                    {
                        secLabel.Text = bandDict[rbutSec];
                    }));
                }
            }
            else
            {
                if (doubleDataArrayRaw.Max() != 0)
                {
                        bandName = bandDict[bandNumber];
                        oldBandName = bandName;
                }
                else
                {
                    bandName = oldBandName;
                }
                reverseBandNumber = reverseDict[bandNumber]; 
            }
            bigBand.BeginInvoke(
                (Action)(() =>
                {
                    bigBand.Text = bandName;
                }));
            Console.WriteLine("BandName is {0}",bandName);
        }
        

        public void SetupForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (Form1.closeflag == false)
            {

                  bandDict = new Dictionary<int, string>()
                                            {
                                                {0, (Properties.Settings.Default.labelA0.Trim()).Substring(0, Properties.Settings.Default.labelA0.IndexOf(' ')) },
                                                {1, (Properties.Settings.Default.labelA1.Trim()).Substring(0, Properties.Settings.Default.labelA1.IndexOf(' ')) },
                                                {2, (Properties.Settings.Default.labelA2.Trim()).Substring(0, Properties.Settings.Default.labelA2.IndexOf(' ')) },
                                                {3, (Properties.Settings.Default.labelA3.Trim()).Substring(0, Properties.Settings.Default.labelA3.IndexOf(' ')) },
                                                {4, (Properties.Settings.Default.labelA4.Trim()).Substring(0, Properties.Settings.Default.labelA4.IndexOf(' ')) },
                                                {5, (Properties.Settings.Default.labelA5.Trim()).Substring(0, Properties.Settings.Default.labelA5.IndexOf(' ')) },
                                                {6, (Properties.Settings.Default.labelA6.Trim()).Substring(0, Properties.Settings.Default.labelA6.IndexOf(' ')) },
                                                {7, (Properties.Settings.Default.labelA7.Trim()).Substring(0, Properties.Settings.Default.labelA7.IndexOf(' ')) },
                                                {8, (Properties.Settings.Default.labelA8.Trim()).Substring(0, Properties.Settings.Default.labelA8.IndexOf(' ')) },
                                                {9, (Properties.Settings.Default.labelA9.Trim()).Substring(0, Properties.Settings.Default.labelA9.IndexOf(' ')) },
                                                {10, (Properties.Settings.Default.labelA10.Trim()).Substring(0, Properties.Settings.Default.labelA10.IndexOf(' ')) },
                                                {11, (Properties.Settings.Default.labelA11.Trim()).Substring(0, Properties.Settings.Default.labelA11.IndexOf(' ')) },
                                                {12, (Properties.Settings.Default.labelA12.Trim()).Substring(0, Properties.Settings.Default.labelA12.IndexOf(' ')) },
                                                {13, (Properties.Settings.Default.labelA13.Trim()).Substring(0, Properties.Settings.Default.labelA13.IndexOf(' ')) },
                                                {14, (Properties.Settings.Default.labelA14.Trim()).Substring(0, Properties.Settings.Default.labelA15.IndexOf(' ')) },
                                                {15, (Properties.Settings.Default.labelA15.Trim()).Substring(0, Properties.Settings.Default.labelA15.IndexOf(' ')) }
                                            };

            reverseDict = new Dictionary<int, int>()
                                            {
                                                {0, Properties.Settings.Default.R0 -1 },
                                                {1, Properties.Settings.Default.R1 -1  },
                                                {2, Properties.Settings.Default.R2 -1   },
                                                {3, Properties.Settings.Default.R3 -1   },
                                                {4, Properties.Settings.Default.R4 -1   },
                                                {5, Properties.Settings.Default.R5 -1   },
                                                {6, Properties.Settings.Default.R6 -1   },
                                                {7, Properties.Settings.Default.R7 -1   },
                                                {8, Properties.Settings.Default.R8 -1   },
                                                {9, Properties.Settings.Default.R9 -1   },
                                                {10, Properties.Settings.Default.R10 -1   },
                                                {11, Properties.Settings.Default.R11 -1   },
                                                {12, Properties.Settings.Default.R12 -1   },
                                                {13, Properties.Settings.Default.R13 -1   },
                                                {14, Properties.Settings.Default.R14 -1   },
                                                {15, Properties.Settings.Default.R15 -1   }
                                            };


        //set new button labels
        butA0.Text = Setup.boxA0.Text;
                butA1.Text = Setup.boxA1.Text;
                butA2.Text = Setup.boxA2.Text;
                butA3.Text = Setup.boxA3.Text;
                butA4.Text = Setup.boxA4.Text;
                butA5.Text = Setup.boxA5.Text;
                butA6.Text = Setup.boxA6.Text;
                butA7.Text = Setup.boxA7.Text;
                butA8.Text = Setup.boxA8.Text;
                butA9.Text = Setup.boxA9.Text;
                butA10.Text = Setup.boxA10.Text;
                butA11.Text = Setup.boxA11.Text;
                butA12.Text = Setup.boxA12.Text;
                butA13.Text = Setup.boxA13.Text;
                butA14.Text = Setup.boxA14.Text;
                butA15.Text = Setup.boxA15.Text;

                //write new labels to properties
                Properties.Settings.Default.labelA0 = butA0.Text;
                Properties.Settings.Default.labelA1 = butA1.Text;
                Properties.Settings.Default.labelA2 = butA2.Text;
                Properties.Settings.Default.labelA3 = butA3.Text;
                Properties.Settings.Default.labelA4 = butA4.Text;
                Properties.Settings.Default.labelA5 = butA5.Text;
                Properties.Settings.Default.labelA6 = butA6.Text;
                Properties.Settings.Default.labelA7 = butA7.Text;
                Properties.Settings.Default.labelA8 = butA8.Text;
                Properties.Settings.Default.labelA9 = butA9.Text;
                Properties.Settings.Default.labelA10 = butA10.Text;
                Properties.Settings.Default.labelA11 = butA11.Text;
                Properties.Settings.Default.labelA12 = butA12.Text;
                Properties.Settings.Default.labelA13 = butA13.Text;
                Properties.Settings.Default.labelA14 = butA15.Text;
                Properties.Settings.Default.labelA15 = butA15.Text;

                Properties.Settings.Default.Save();

                //check validity of IP addresses and return to setup if invalid
                int res1;
                int res2;
                int res3;
                int res4;
                bool result1 = int.TryParse(Setup.boxIP1.Text, out res1);
                bool result2 = int.TryParse(Setup.boxIP2.Text, out res2);
                bool result3 = int.TryParse(Setup.boxIP3.Text, out res3);
                bool result4 = int.TryParse(Setup.boxIP4.Text, out res4);
                bool result5 = res1 < 0 || res1 > 255 || res2 < 0 || res2 > 255 || res3 < 0 || res3 > 255 || res4 < 0 || res4 > 255;
                if (result1 && result2 && result3 && result4 && !result5)
                {
                    Properties.Settings.Default.thisIP = Setup.boxIP1.Text + "." + Setup.boxIP2.Text + "." + Setup.boxIP3.Text + "." + Setup.boxIP4.Text;
                    Properties.Settings.Default.Save();
                    Setup.oldIP1 = Setup.boxIP1.Text;
                    Setup.oldIP2 = Setup.boxIP2.Text;
                    Setup.oldIP3 = Setup.boxIP3.Text;
                    Setup.oldIP4 = Setup.boxIP4.Text;
                    badCompIP = false;
                }
                else
                {
                    Setup.boxIP1.Text = Setup.oldIP1;
                    Setup.boxIP2.Text = Setup.oldIP2;
                    Setup.boxIP3.Text = Setup.oldIP3;
                    Setup.boxIP4.Text = Setup.oldIP4;
                    badCompIP = true;
                    MessageBox.Show("Bad Computer IP Address.  Go back to Setup and Try Again!");
                }

                int res1a;
                int res2a;
                int res3a;
                int res4a;
                bool result1a = int.TryParse(Setup.boxArdIP1.Text, out res1a);
                bool result2a = int.TryParse(Setup.boxArdIP2.Text, out res2a);
                bool result3a = int.TryParse(Setup.boxArdIP3.Text, out res3a);
                bool result4a = int.TryParse(Setup.boxArdIP4.Text, out res4a);
                bool result5a = res1a < 0 || res1a > 255 || res2a < 0 || res2a > 255 || res3a < 0 || res3a > 255 || res4a < 0 || res4a > 255;
                if (result1a && result2a && result3a && result4a && !result5a)
                {
                    Properties.Settings.Default.arduinoIP = Setup.boxArdIP1.Text + "." + Setup.boxArdIP2.Text + "." + Setup.boxArdIP3.Text + "." + Setup.boxArdIP4.Text;
                    Properties.Settings.Default.Save();
                    Setup.oldArdIP1 = Setup.boxArdIP1.Text;
                    Setup.oldArdIP2 = Setup.boxArdIP2.Text;
                    Setup.oldArdIP3 = Setup.boxArdIP3.Text;
                    Setup.oldArdIP4 = Setup.boxArdIP4.Text;
                    badArdIP = false;
                }
                else
                {
                    Setup.boxArdIP1.Text = Setup.oldArdIP1;
                    Setup.boxArdIP2.Text = Setup.oldArdIP2;
                    Setup.boxArdIP3.Text = Setup.oldArdIP3;
                    Setup.boxArdIP4.Text = Setup.oldArdIP4;
                    badArdIP = true;
                    MessageBox.Show("Bad Arduino IP Address.  Go back to Setup and Try Again!");
                }
                if (badArdIP || badCompIP)
                {
                    gotoSetup();
                }
            }
        }

        public static byte[] StrToByteArray(string str)
        {
            System.Text.UTF8Encoding encoding = new System.Text.UTF8Encoding();
            return encoding.GetBytes(str);
        }


        public async Task sendCommandAsync(byte[] command, string endpoint, int port)
        {
            Task task = Task.Run(() => sendCommand(command, endpoint, port));
            await task;
        }

        public void sendCommand(byte[] command, string endpoint, int port)
        {
            int commandLength = command.Length;
            udpServer1.Send(command, commandLength, localpt1); // reply back  //w3sz 
        }


        private void butA0_Click(object sender, EventArgs e)
        {
            if (BANDA0 == "ON")
            {
                BANDA0 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA0OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA0.BackColor = SystemColors.Control;
                Properties.Settings.Default.A0 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA0 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA0ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA0.BackColor = Color.Yellow;
                Properties.Settings.Default.A0 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA1_Click(object sender, EventArgs e)
        {

            if (BANDA1 == "ON")
            {
                BANDA1 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA1OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA1.BackColor = SystemColors.Control;
                Properties.Settings.Default.A1 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA1 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA1ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA1.BackColor = Color.Yellow;
                Properties.Settings.Default.A1 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA2_Click(object sender, EventArgs e)
        {

            if (BANDA2 == "ON")
            {
                BANDA2 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA2OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA2.BackColor = SystemColors.Control;
                Properties.Settings.Default.A2 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA2 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA2ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA2.BackColor = Color.Yellow;
                Properties.Settings.Default.A2 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA3_Click(object sender, EventArgs e)
        {

            if (BANDA3 == "ON")
            {
                BANDA3 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA3OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA3.BackColor = SystemColors.Control;
                Properties.Settings.Default.A3 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA3 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA3ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA3.BackColor = Color.Yellow;
                Properties.Settings.Default.A3 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA4_Click(object sender, EventArgs e)
        {

            if (BANDA4 == "ON")
            {
                BANDA4 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA4OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA4.BackColor = SystemColors.Control;
                Properties.Settings.Default.A4 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA4 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA4ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA4.BackColor = Color.Yellow;
                Properties.Settings.Default.A4 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA5_Click(object sender, EventArgs e)
        {

            if (BANDA5 == "ON")
            {
                BANDA5 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA5OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA5.BackColor = SystemColors.Control;
                Properties.Settings.Default.A5 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA5 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA5ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA5.BackColor = Color.Yellow;
                Properties.Settings.Default.A5 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA6_Click(object sender, EventArgs e)
        {

            if (BANDA6 == "ON")
            {
                BANDA6 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA6OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA6.BackColor = SystemColors.Control;
                Properties.Settings.Default.A6 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA6 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA6ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA6.BackColor = Color.Yellow;
                Properties.Settings.Default.A6 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA7_Click(object sender, EventArgs e)
        {

            if (BANDA7 == "ON")
            {
                BANDA7 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA7OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA7.BackColor = SystemColors.Control;
                Properties.Settings.Default.A7 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA7 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA7ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA7.BackColor = Color.Yellow;
                Properties.Settings.Default.A7 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA8_Click(object sender, EventArgs e)
        {

            if (BANDA8 == "ON")
            {
                BANDA8 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA8OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA8.BackColor = SystemColors.Control;
                Properties.Settings.Default.A8 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA8 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA8ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA8.BackColor = Color.Yellow;
                Properties.Settings.Default.A8 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA9_Click(object sender, EventArgs e)
        {

            if (BANDA9 == "ON")
            {
                BANDA9 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA9OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA9.BackColor = SystemColors.Control;
                Properties.Settings.Default.A9 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA9 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA9ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA9.BackColor = Color.Yellow;
                Properties.Settings.Default.A9 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA10_Click(object sender, EventArgs e)
        {

            if (BANDA10 == "ON")
            {
                BANDA10 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA10OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA10.BackColor = SystemColors.Control;
                Properties.Settings.Default.A10 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA10 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA10ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA10.BackColor = Color.Yellow;
                Properties.Settings.Default.A10 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA11_Click(object sender, EventArgs e)
        {

            if (BANDA11 == "ON")
            {
                BANDA11 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA11OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA11.BackColor = SystemColors.Control;
                Properties.Settings.Default.A11 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA11 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA11ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA11.BackColor = Color.Yellow;
                Properties.Settings.Default.A11 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA12_Click(object sender, EventArgs e)
        {

            if (BANDA12 == "ON")
            {
                BANDA12 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA12OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA12.BackColor = SystemColors.Control;
                Properties.Settings.Default.A12 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA12 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA12ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA12.BackColor = Color.Yellow;
                Properties.Settings.Default.A12 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA13_Click(object sender, EventArgs e)
        {

            if (BANDA13 == "ON")
            {
                BANDA13 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA13OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA13.BackColor = SystemColors.Control;
                Properties.Settings.Default.A13 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA13 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA13ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA13.BackColor = Color.Yellow;
                Properties.Settings.Default.A13 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA14_Click(object sender, EventArgs e)
        {

            if (BANDA14 == "ON")
            {
                BANDA14 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA14OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA14.BackColor = SystemColors.Control;
                Properties.Settings.Default.A14 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA14 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA14ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA14.BackColor = Color.Yellow;
                Properties.Settings.Default.A14 = "ON";
                Properties.Settings.Default.Save();
            }
        }

        private void butA15_Click(object sender, EventArgs e)
        {

            if (BANDA15 == "ON")
            {
                BANDA15 = "OFF";
                byte[] textstrng = StrToByteArray("~BANDA15OFF$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA15.BackColor = SystemColors.Control;
                Properties.Settings.Default.A15 = "OFF";
                Properties.Settings.Default.Save();
            }
            else
            {
                BANDA15 = "ON";
                byte[] textstrng = StrToByteArray("~BANDA15ON$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                butA15.BackColor = Color.Yellow;
                Properties.Settings.Default.A15 = "ON";
                Properties.Settings.Default.Save();
            }
        }


        private void startButton_Click(object sender, EventArgs e)
        {
            if (PowerOn == "ON")
            {
                PowerOn = "OFF";
                byte[] textstrng = StrToByteArray("~STOP$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                startButton.BackColor = SystemColors.Control;
            }
            else
            {
                PowerOn = "ON";
                byte[] textstrng = StrToByteArray("~START$"); //w3sz  convert to byte array
                sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
                startButton.BackColor = Color.Yellow;
            }

        }

        protected override void OnFormClosing(FormClosingEventArgs e)
        {
            closeflag = true;
            PowerOn = "OFF";
            byte[] textstrng = StrToByteArray("~STOP$"); //w3sz  convert to byte array
            sendCommandAsync(textstrng, Properties.Settings.Default.arduinoIP, dataPort);
            startButton.BackColor = SystemColors.Control;
            base.OnFormClosing(e);
        }

        private void radioButton0a_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton0a.Checked)
            {
                rbutRev = 0;
                Properties.Settings.Default.rbutRev = 0;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton1a_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1a.Checked)
            {
                rbutRev = 1;
                Properties.Settings.Default.rbutRev = 1;
                Properties.Settings.Default.Save();
            }

        }

        private void radioButton2a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton2a.Checked)
            {
                rbutRev = 2;
                Properties.Settings.Default.rbutRev = 2;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton3a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton3a.Checked)
            {
                rbutRev = 3;
                Properties.Settings.Default.rbutRev = 3;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton4a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton4a.Checked)
            {
                rbutRev = 4;
                Properties.Settings.Default.rbutRev = 4;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton5a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton5a.Checked)
            {
                rbutRev = 5;
                Properties.Settings.Default.rbutRev = 5;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton6a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton6a.Checked)
            {
                rbutRev = 6;
                Properties.Settings.Default.rbutRev = 6;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton7a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton7a.Checked)
            {
                rbutRev = 7;
                Properties.Settings.Default.rbutRev = 7;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton8a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton8a.Checked)
            {
                rbutRev = 8;
                Properties.Settings.Default.rbutRev = 8;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton9a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton9a.Checked)
            {
                rbutRev = 9;
                Properties.Settings.Default.rbutRev = 9;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton10a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton10a.Checked)
            {
                rbutRev = 10;
                Properties.Settings.Default.rbutRev = 10;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton11a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton11a.Checked)
            {
                rbutRev = 11;
                Properties.Settings.Default.rbutRev = 11;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton12a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton12a.Checked)
            {
                rbutRev = 12;
                Properties.Settings.Default.rbutRev = 12;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton13a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton13a.Checked)
            {
                rbutRev = 13;
                Properties.Settings.Default.rbutRev = 13;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton14a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton14a.Checked)
            {
                rbutRev = 14;
                Properties.Settings.Default.rbutRev = 14;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton15a_CheckedChanged(object sender, EventArgs e)
        {

            if (radioButton15a.Checked)
            {
                rbutRev = 15;
                Properties.Settings.Default.rbutRev = 15;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButtonNONE_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonNONE.Checked)
            {
                rbutRev = 99;
                Properties.Settings.Default.rbutRev = rbutRev;
                Properties.Settings.Default.Save();
            }
        }
        
        private void radioButton0_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton0.Checked)
            {
                rbutGraph = 0;
                Properties.Settings.Default.rbutGraph = 0;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked)
            {
                rbutGraph = 1;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton2.Checked)
            {
                rbutGraph = 2;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton3.Checked)
            {
                rbutGraph = 3;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton4.Checked)
            {
                rbutGraph = 4;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton5_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton5.Checked)
            {
                rbutGraph = 5;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton6_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton6.Checked)
            {
                rbutGraph = 6;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton7_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton7.Checked)
            {
                rbutGraph = 7;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton8_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton8.Checked)
            {
                rbutGraph = 8;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton9_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton9.Checked)
            {
                rbutGraph = 9;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton10_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton10.Checked)
            {
                rbutGraph = 10;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton11_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton11.Checked)
            {
                rbutGraph = 11;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton12_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton12.Checked)
            {
                rbutGraph = 12;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton13_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton13.Checked)
            {
                rbutGraph = 13;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton14_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton14.Checked)
            {
                rbutGraph = 14;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton15_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton15.Checked)
            {
                rbutGraph = 15;
                Properties.Settings.Default.rbutGraph = rbutGraph;
                Properties.Settings.Default.Save();
            }
        }

        private void butSetup_Click(object sender, EventArgs e)
        {
            gotoSetup();
        }

        private void gotoSetup ()
        {
            // only allow user to open form if not already open
            if (!SetupValid())
            {
                Setup = new SetupForm(this);
                Setup.TopMost = true;          // have the setup form appear over the main form.
                Setup.Owner = this;
                Setup.ShowDialog();                  // display the Setup form 
            }
            else  // form already open 
            {
                // handle setup form already being shown.  Make sure the user sees it...
                if (badArdIP == false && badCompIP == false)
                {
                    Setup.ShowDialog();
                }
                else
                { badCompIP = false;  badArdIP = false; }
            }

        }

        private bool SetupValid()
        {
            // if the form is null or disposed, it is NOT valid
            if (Setup == null || Setup.IsDisposed)
                return false;
            else
                return true;
        }

        private void maxMinBut_Click(object sender, EventArgs e)
        {
            if(maxSize == true)
            {
                oneOrTwo(Properties.Settings.Default.autoBand,rbutSec);
            }
            else
            {
                maxSize = true;
                instSec.Visible = false;
                avgSec.Visible = false;
                bigBand.Visible = true;
                label1.Visible = true;
                label5.Visible = true;
                label6.Visible = true;
                label7.Visible = true;
                bandLabel.Visible = false;
                secLabel.Visible = false;
                bandMHz.Visible = false;
                secMHz.Visible = false;
                this.Size = new Size(1198,859);
                maxMinBut.Location = new Point(1103, 755);
                checkBox1.Location = new Point(1013, 756);
                bigBand.Size = new Size(204, 80);
                bigBand.Location = new Point(151, 688);
                bigBand.Font = new System.Drawing.Font("Microsoft Sans Serif", 72F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                bigAvg.Size = new Size(204, 116);
                bigAvg.Location = new Point(905, 51);
                bigAvg.Font = new System.Drawing.Font("Microsoft Sans Serif", 72F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                bigInst.Size = new Size(204, 116);
                bigInst.Location = new Point(905, 173);
                bigInst.Font = new System.Drawing.Font("Microsoft Sans Serif", 72F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                bigSWR.Size = new Size(204, 116);
                bigSWR.Location = new Point(905,295 );
                bigSWR.Font = new System.Drawing.Font("Microsoft Sans Serif", 72F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                PowerGraph.Size = new Size(887, 436);
                PowerGraph.Location = new Point(12, 12);
                label1.Size = new Size(64, 25);
                label5.Size = new Size(59, 25);
                label6.Size = new Size(63, 25);
                label7.Size = new Size(64, 25);
                label1.Location = new Point(361, 721);
                label5.Location = new Point(1115, 96);
                label6.Location = new Point(1115, 219);
                label7.Location = new Point(1113, 336);
                label1.Text = "BAND";
                label5.Text = "AVG";
                label6.Text = "INST";
                label7.Text = "SWR";
                label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            }
        }


        void oneOrTwo(bool autoBa, int secBa)
        {
            maxSize = false;
            this.Size = new Size(500, 300);
            maxMinBut.Location = new Point(408, 238);
            checkBox1.Location = new Point(330, 241);
            bigSWR.Size = new Size(100, 50);
            bigSWR.Location = new Point(360, 190);
            bigSWR.Font = new System.Drawing.Font("Microsoft Sans Serif", 22F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            PowerGraph.Size = new Size(350, 260);
            PowerGraph.Location = new Point(10, 10);
            if (autoBa || (secBa == 99))
            {
                //don't show two bands
                bandLabel.Visible = false;
                secLabel.Visible = false;
                bandMHz.Visible = false;
                secMHz.Visible = false;
                instSec.Visible = false;
                avgSec.Visible = false;
                bigBand.Visible = true;
                label1.Visible = true;
                label5.Visible = true;
                label6.Visible = true;
                label7.Visible = true;
                //this gives only 1 band display
                bigBand.Size = new Size(100, 50);
                bigBand.Location = new Point(360, 10);
                bigBand.Font = new System.Drawing.Font("Microsoft Sans Serif", 22F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                bigAvg.Size = new Size(100, 50);
                bigAvg.Location = new Point(360, 70);
                bigAvg.Font = new System.Drawing.Font("Microsoft Sans Serif", 22F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                bigInst.Size = new Size(100, 50);
                bigInst.Location = new Point(360, 130);
                bigInst.Font = new System.Drawing.Font("Microsoft Sans Serif", 22F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                label1.Size = new Size(25, 64);
                label5.Size = new Size(25, 59);
                label6.Size = new Size(25, 63);
                label7.Size = new Size(25, 64);
                label1.Location = new Point(465, 2);
                label5.Location = new Point(465, 70);
                label6.Location = new Point(465, 122);
                label7.Location = new Point(465, 188);
                label1.Text = "B\nA\nN\nD";
                label5.Text = "A\nV\nG";
                label6.Text = "I\nN\nS\nT";
                label7.Text = "S\nW\nR";
                label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 7.5F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 7.5F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 7.5F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 7.5F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            }
            else if (!autoBa && (secBa < 99))
            {
                //this gives displays for two bands
                bandLabel.Visible = true;
                secLabel.Visible = true;
                bandMHz.Visible = true;
                secMHz.Visible = true;
                instSec.Visible = true;
                avgSec.Visible = true;
                bigBand.Visible = false;
                label1.Visible = false;
                label5.Visible = true;
                label6.Visible = true;
                label7.Visible = true;
                bandLabel.Location = new Point(380,10);
                bandMHz.Location = new Point(bandLabel.Location.X + bandLabel.Width,10);

                bigAvg.Size = new Size(100, 50);
                bigAvg.Location = new Point(360, 30);
                bigAvg.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                bigInst.Size = new Size(100, 50);
                bigInst.Location = new Point(360, 60);
                bigInst.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));

                secLabel.Location = new Point(380, 100);
                secMHz.Location = new Point(secLabel.Location.X + secLabel.Width, 100);
                avgSec.Size = new Size(100, 50);
                avgSec.Location = new Point(360, 120);
                avgSec.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                instSec.Size = new Size(100, 50);
                instSec.Location = new Point(360, 150);
                instSec.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                
                label5.Size = new Size(25, 59);
                label6.Size = new Size(25, 63);
                label7.Size = new Size(25, 64);
                label5.Location = new Point(465, 32);
                label6.Location = new Point(465, 125);
                label7.Location = new Point(465, 188);
                label5.Text = "M\nA\nI\nN";
                label6.Text = "S\nE\nC";
                label7.Text = "S\nW\nR";
                label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 7.5F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 7.5F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 7.5F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));

            }

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if(checkBox1.Checked)
            {
                Properties.Settings.Default.autoBand = true;
            }
            else
            {
                Properties.Settings.Default.autoBand = false;
            }
            Properties.Settings.Default.Save();
            if (!maxSize)
            {
                oneOrTwo(Properties.Settings.Default.autoBand, rbutSec);
            }
        }

        private void radioButtonSec_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonSec.Checked)
            {
                rbutSec = 99;
                Properties.Settings.Default.rbutSec = rbutSec;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton0b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton0b.Checked)
            {
                rbutSec = 0;
                Properties.Settings.Default.rbutSec = 0;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton1b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1b.Checked)
            {
                rbutSec = 1;
                Properties.Settings.Default.rbutSec = 1;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton2b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton2b.Checked)
            {
                rbutSec = 2;
                Properties.Settings.Default.rbutSec = 2;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton3b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton3b.Checked)
            {
                rbutSec = 3;
                Properties.Settings.Default.rbutSec = 3;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton4b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton4b.Checked)
            {
                rbutSec = 4;
                Properties.Settings.Default.rbutSec = 4;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton5b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton5b.Checked)
            {
                rbutSec = 5;
                Properties.Settings.Default.rbutSec = 5;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton6b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton6b.Checked)
            {
                rbutSec = 6;
                Properties.Settings.Default.rbutSec = 6;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton7b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton7b.Checked)
            {
                rbutSec = 7;
                Properties.Settings.Default.rbutSec = 7;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton8b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton8b.Checked)
            {
                rbutSec = 8;
                Properties.Settings.Default.rbutSec = 8;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton9b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton9b.Checked)
            {
                rbutSec = 9;
                Properties.Settings.Default.rbutSec = 9;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton10b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton10b.Checked)
            {
                rbutSec = 10;
                Properties.Settings.Default.rbutSec = 10;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton11b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton11b.Checked)
            {
                rbutSec = 11;
                Properties.Settings.Default.rbutSec = 11;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton12b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton12b.Checked)
            {
                rbutSec = 12;
                Properties.Settings.Default.rbutSec = 12;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton13b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton13b.Checked)
            {
                rbutSec = 13;
                Properties.Settings.Default.rbutSec = 13;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton14b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton14b.Checked)
            {
                rbutSec = 14;
                Properties.Settings.Default.rbutSec = 14;
                Properties.Settings.Default.Save();
            }
        }

        private void radioButton15b_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton15b.Checked)
            {
                rbutSec = 15;
                Properties.Settings.Default.rbutSec = 15;
                Properties.Settings.Default.Save();
            }
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            Properties.Settings.Default.avgDuration = trackBar1.Value;
            Properties.Settings.Default.Save();
            avgDur = (int)Math.Pow(10.0, trackBar1.Value / 100.0);
            Console.WriteLine("avgDur = {0}", avgDur);
        }
    }
}
